%function locateBifurcation()

clc
clear all
close all


database = cell2mat(struct2cell(load('databaseall.mat')));
allones = ones(1,9);
allzeros = zeros(1,9);
database = [allones;database;allzeros];

%database = database(1,:);
[r c] = size(database);
C = permute(database,[3 2 1]);
P = reshape(C,3,3,r);

database = mat2cell(database', 9, ones(1,size(database,1)));


targets = 1:size(database,2)-2;
targets = [0, targets, 5];
targets = num2cell(targets);

% [net, tr] = NNet(database,targets);
% output = sim(net,database);
% output = round(cell2mat(output));
% break

network_vars = load('trained_all.mat');
databaseNet = network_vars.net;

% filename = 'fingerprint2.jpg';
% I = imread(filename);
% 
% [FP] = preprocess(I);

FP = [0 1 1 0 1 0 1 0 1;...
      0 0 1 0 0 1 1 0 1;...
      1 0 1 1 0 1 0 1 0;...
      1 1 1 1 1 1 1 1 1];...
      %1 1 1 1 1 1 1 1 1];

  

%raster binary image matrix into 3x3 segments
M = im2col(FP, [3,3],'sliding');

[ri ci] = size(FP);
%[rM cM] = size(M);
rM = 9;
cM = (ci-2)*(ri-2);

%Generate table of locations in binary image matrix for center point (2,2)
%of segment matrices
rownums = repmat([2:ri-1],cM/(ri-2),1);
rownums = rownums(:);

colnums = repmat([2:ci-1]',1,cM/(ci-2));
colnums = colnums(:);

locations = [rownums,colnums];
clear rownums colnums
n = 1;

k = 1; 

for row = 1:ri-2
 
	for col = 1:ci-2
  
            sM = FP(row:row+2,col:col+2);
            cellsM = mat2cell(sM(:), 9, 1);
            
           
            outputs = sim(databaseNet,cellsM);
            if abs(round(cell2mat(outputs)) - cell2mat(outputs)) < 0.00001
                outputs = round(cell2mat(outputs));
                [ismatched, matched, ind] = getMatch(outputs, targets);
                %[pattern_num ind] = find(outputs == targets);
                
                if ismatched == 1 && outputs ~= 0 && outputs ~= r
                    %transform center point location in raster segment
                    %to corresponding location in the original image
                    Iloc(n,:) = locations(k,:);
                    n = n+1; 
                end
            
            else
                k = k+1;
                continue
            end
    k = k+1;
	end
	
end


%color raster segment center point red
logic = logical(FP);
RGB = 255*zeros(ri,ci,3);

for L = 1:size(Iloc,1)
    RGB(Iloc(L,1),Iloc(L,2),:) = [255,0,0];

    % subplot(3,1,1)
    % imagesc(RGB./255)
    % title('RGB matrix')
    % axis off

    % subplot(3,1,2)
    % imagesc(logic)
    % title('Logical mask');
    % axis off

    [R, G, B] = deal(RGB(:,:,1),RGB(:,:,2),RGB(:,:,3)) ;
    R(logic)=255;
    G(logic)=255;
    B(logic)=255;
    RGB = cat(3,R,G,B);
    figure(3)
    imagesc(RGB./255)
    axis off
    axis equal
    hold on

end

