function [ismatched, matched, ind] = getMatch(outputs, targets)
%return logic array for matched values between outputs and targets

targets = cell2mat(targets);

ind = bsxfun(@eq,outputs,targets);          %logical matrix of matching fields
ind = all(ind,1);                           %logical array of columns that contain only ones
num_matches = sum(ind);
ismatched = any(ind);                       %returns zero if nothing matches, 1 if something matches


matched = targets(1,logical(ind));
